Attribute VB_Name = "basErrorHandling"
Option Explicit
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
    
Public Const conHwndTopmost = -1
Public Const conSwpNoActivate = &H10
Public Const conSwpShowWindow = &H40

Public mProcStack As New ProcedureStack

Public Function Process_Error(strModuleName As String, mErr As ErrObject, strProcName As String)

Dim Procedure As String
Procedure = strProcName
Dim Module As String
Module = strModuleName
Dim ErrorNumber As String
ErrorNumber = mErr.Number
Dim ErrorDescription As String
ErrorDescription = mErr.Description
Dim ErrorSource As String
ErrorSource = mErr.Source
Dim LastDllError As String
LastDllError = mErr.LastDllError

Dim objProc As Procedure

txt_AppendLine App.Path & "\" & "ErrorLogs.txt", ""
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", ""
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", ""
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "##################################################################################################################################################################"
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "# Date: " & Format(Now, "dd.mm.yyyy @ hh:mm:ss")
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "# Procedure Name: " & Procedure
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "# Module Name: " & Module
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "# Error Number: " & ErrorNumber
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "# Error Description: " & ErrorDescription
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "# Error Source: " & ErrorSource
txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "# Last DLL Error: " & LastDllError

Set objProc = mProcStack.Top

Do Until objProc Is Nothing
    txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "# Call Stack: " & objProc.Name & " in " & objProc.Module
    Set objProc = objProc.NextProc
Loop

txt_AppendLine App.Path & "\" & "ErrorLogs.txt", "##################################################################################################################################################################"

End Function


