Attribute VB_Name = "LineRemove"
Option Explicit
Const MODULE_NAME As String = "LineRemove"

Public Function SearchRemoveLine(Text As String, SearchString As String, Replace As Boolean, ReplaceString As String)
'/* Begin Error Handler
On Error GoTo HandleError
    Call mProcStack.EnterProc("SearchRemoveLine", MODULE_NAME)

Dim NewText As String

Dim Lines As Long
Lines = StrCount(Text, vbNewLine)

Dim i As Long

If Replace = False Then
For i = 0 To Lines
    If Split(Text, vbNewLine)(i) = Empty Then GoTo SkipNormal
    If InStr(Split(Text, vbNewLine)(i), SearchString) Then
    Else
        If i = 0 Then
        NewText = Split(Text, vbNewLine)(i) & vbNewLine
        ElseIf i < Lines - 1 Then
        NewText = NewText & Split(Text, vbNewLine)(i) & vbNewLine
        Else
        NewText = NewText & Split(Text, vbNewLine)(i)
        End If
    End If
SkipNormal:
Next i
ElseIf Replace = True Then
For i = 0 To Lines
    If Split(Text, vbNewLine)(i) = "" Then GoTo SkipReplace
    If InStr(Split(Text, vbNewLine)(i), SearchString) Then
        If i = 0 Then
        NewText = ReplaceString & vbNewLine
        ElseIf i < Lines - 1 Then
        NewText = NewText & ReplaceString & vbNewLine
        Else
        NewText = NewText & ReplaceString
        End If
    Else
        If i = 0 Then
        NewText = NewText & Split(Text, vbNewLine)(i)
        ElseIf i < Lines - 1 Then
        NewText = NewText & Split(Text, vbNewLine)(i) & vbNewLine
        Else
        NewText = NewText & Split(Text, vbNewLine)(i)
        End If
    End If
SkipReplace:
Next i
End If

SearchRemoveLine = NewText

'/* End Error Handler
SearchRemoveLine_Done:
    Call mProcStack.ExitProc("SearchRemoveLine")
    Exit Function

HandleError:
    Process_Error MODULE_NAME, Err, "SearchRemoveLine"
    Resume SearchRemoveLine_Done

End Function

Public Function RemoveBlankLines(Text As String)
'/* Begin Error Handler
On Error GoTo HandleError
    Call mProcStack.EnterProc("RemoveBlankLines", MODULE_NAME)

Dim NewText As String

Dim Lines As Long
Lines = StrCount(Text, vbNewLine)

Dim i As Long

For i = 0 To Lines
    If Split(Text, vbNewLine)(i) = "" Then
    Else
        If i = 0 Then
        NewText = Split(Text, vbNewLine)(i) & vbNewLine
        ElseIf i < Lines Then
        NewText = NewText & Split(Text, vbNewLine)(i) & vbNewLine
        ElseIf i = Lines Then
        NewText = NewText & Split(Text, vbNewLine)(i)
        End If
    End If
Next i

RemoveBlankLines = NewText

'/* End Error Handler
RemoveBlankLines_Done:
    Call mProcStack.ExitProc("RemoveBlankLines")
    Exit Function

HandleError:
    Process_Error MODULE_NAME, Err, "RemoveBlankLines"
    Resume RemoveBlankLines_Done

End Function
